/**
 * 
 */
package components;

import sim.BasicComponent;
import sim.Component;
import sim.LogicLevel;
import sim.Port;
import sim.PortDirection;
import sim.Simulator;

/**
 * Class representing a 2 input And gate
 * @author Tanmay
 *
 */
public class AndGate extends BasicComponent {

	// Fields
	private Port inputA;
	private Port inputB;
	private Port outputS;
	private int propagationDelay = 5; // nanoseconds
	
	/**
	 * Constructor for an And Gate
	 */
	public AndGate(){
		inputA = new Port(this,PortDirection.INPUT);
		inputB = new Port(this,PortDirection.INPUT);
		outputS = new Port(this, PortDirection.OUTPUT);
	}
	
	@Override
	public void operation(){
		
		LogicLevel newLevel = compute();
		
		outputS.setLogicLevel(newLevel);
		Simulator.getSimulator().addEvent(outputS.getConnectedWire(),
				outputS.getLogicLevel(), propagationDelay);
	
	}
	
	// Method to perform the Anding
	private LogicLevel compute(){
		LogicLevel newLevel; 
		if(inputA.getLogicLevel() == LogicLevel.HIGH && 
				inputA.getLogicLevel() == LogicLevel.HIGH){

			newLevel = LogicLevel.HIGH;
		}else{
			newLevel = LogicLevel.LOW;
		}
		return newLevel;
	}


}
