package components;

import java.io.PrintStream;

import sim.BasicComponent;
import sim.Port;
import sim.PortDirection;
import sim.Simulator;

/**
 * Class to represent a simple signal probe to 
 * print changes in signal value to the given 
 * stream.
 * @author Tanmay
 *
 */
public class Probe extends BasicComponent {

	private Port input;
	private Port output;
	private PrintStream printDestination;
	
	public Probe(PrintStream os){

		input = new Port(this,PortDirection.INPUT);
		output = new Port(this, PortDirection.OUTPUT);
		this.printDestination = os;
		
	}
	
	@Override
	public void operation() {

		Simulator sim = Simulator.getSimulator();
		printDestination.println(sim.getCurrentTime()+propagationDelay+ 
				" " + output.getConnectedWire().getName()+ " " + input.getLogicLevel());
		sim.addEvent(output.getConnectedWire(),
				input.getLogicLevel(), propagationDelay);
		
	}



}
