package sim;

/**
 * Abstract class to represent all basic system components like 
 * And/OR/XOR Gates, Probes etc.
 * @author Tanmay
 *
 */
public abstract class BasicComponent implements Component {

	// The standard propagation delay through any component
	protected int propagationDelay = 2;
	
	@Override
	public void addComponent(Component c) {
		
	}

	@Override
	public Component getChild(int i) {
		// Returns null because a basic component 
		// does not have children
		return null;
	}

	@Override
	public void removeComponent(Component c) {
		
	}
}
