 /**
 * 
 */
package sim;

import java.util.Observable;
import java.util.Observer;


/**
 * Class to model a Wire used in a circuit
 * @author Tanmay Bhola
 *
 */
public class Wire extends Observable {

	// Fields
	private String name;
	private LogicLevel logicLevel;
	
	/**
	 * Constructor for a Wire
	 * @param The name of the wire 
	 */
	public Wire(String name) {
		this.name = name;
		this.logicLevel = LogicLevel.LOW;
	}
	
	// Getters and Setters

	/**
	 * @return the value
	 */
	public LogicLevel getLogicLevel() {
		return logicLevel;
	}

	/**
	 * @param value the value to set
	 */
	public void setLogicLevel(LogicLevel newLevel) {
		
		if(logicLevel != newLevel){
			setChanged();
			notifyObservers(newLevel);
		}
		logicLevel = newLevel;
	}


	/**
	 * @return the name
	 */
	public String getName() {
		return name;
	}


	/**
	 * @param name the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}
	

}
